// =====================================================================================
// Includes
// =====================================================================================

#include "global.h"

#include "LED_display.h"
#include "Key_Panel.h"
#include "LED_row.h"
#include "ISR.h"

// =====================================================================================
// ISR zum Entprellen der Tasten
// =====================================================================================

ISR(TIMER2_OVF_vect)
{
	static uint16_t ct0, ct1;
	uint16_t i;
	uint16_t pin_State;

	TCNT2 = (uint8_t)(int16_t)-(F_CPU / 1024 * 10e-3 + 0.5);

	i = PINA | (((PINE & 0b00000111) | (PINC & 0b01100000)) << 8);
	i = key_state ^ ~i;
	ct0 = ~( ct0 & i);
	ct1 = ct0 ^ (ct1 & i);
	i &= ct0 & ct1;
	key_state ^= i;
	key_press |= key_state & i;
}

// =====================================================================================
// ISR fr Multiplexing des LED Displays
// =====================================================================================

ISR(TIMER0_COMP_vect)
{
	uint8_t segmente;

	if (display_on==1)
	{
		// aktuelle Ziffer im Multiplexing
		aktStelle++;
		if (aktStelle==4)
		{
			aktStelle=0;
		}

		// alle Ziffern ausschalten
		PORTC &= ~(DIG_1 | DIG_2 | DIG_3 | DIG_4);

		// Segmente aktivieren
		memcpy_P(&segmente, segmente_array + digit[aktStelle], sizeof(uint8_t));
		PORTD = segmente;

		// Ziffer aktivieren
		PORTC |= (1<<(3-aktStelle));
	}
}