// =====================================================================================
// Includes
// =====================================================================================

#include "global.h"

#include "LED_display.h"
#include "Key_Panel.h"
#include "LED_row.h"
#include "ISR.h"

// =====================================================================================
// ISR zum Entprellen der Tasten
// =====================================================================================

//ISR(TIMER2_OVF_vect)
//{
	//static uint16_t ct0, ct1;
	//uint16_t i;
	//uint16_t pin_State;
//
	//TCNT2 = (uint8_t)(int16_t)-(F_CPU / 1024 * 10e-3 + 0.5);
//
	//i = PINA | (((PINE & 0b00000111) | (PINC & 0b01100000)) << 8);
	//i = key_state ^ ~i;
	//ct0 = ~( ct0 & i);
	//ct1 = ct0 ^ (ct1 & i);
	//i &= ct0 & ct1;
	//key_state ^= i;
	//key_press |= key_state & i;
//}

// =====================================================================================
// Initialisierung des Tastenfelds (Ports, Timer, Interrupt)
// =====================================================================================

void Key_Panel_init()
{
	DDRA = 0;
	PORTA = 255;

	DDRE &= ~((1<<PE0)|(1<<PE1)|(1<<PE2));
	PORTE = (1<<PE0)|(1<<PE1)|(1<<PE2);

	DDRC &= ~((1<<PC6)|(1<<PC5));
	PORTC |= (1<<PC6)|(1<<PC5);

	TCCR2 = (1<<CS22)|(1<<CS21)|(1<<CS20);
	TCNT2 = (uint8_t)(int16_t)-(F_CPU / 1024 * 10e-3 + 0.5);
	TIMSK |= 1<<TOIE2;

	sei();
}

// =====================================================================================
// Auswertung der Entprellung und Ermittlung der gedrckten Taste
// =====================================================================================

uint8_t Key_Panel_getKey()
{
	uint8_t result = 99;

	cli();

	if (key_press>0)
	{
		switch (key_press)
		{
			case (1<<0): result = 11; break;
			case (1<<1): result = 4; break;
			case (1<<2): result = 1; break;
			case (1<<3): result = 0; break;
			case (1<<4): result = 8; break;
			case (1<<5): result = 5; break;
			case (1<<6): result = 2; break;
			case (1<<7): result = 12; break;
			case (1<<8): result = 9; break;
			case (1<<9): result = 6; break;
			case (1<<10): result = 3; break;
			case (1<<13): result = 13; break;
			case (1<<14): result = 14; break;
		}
		key_press = 0;
	}

	sei();
	return result;
}