// =====================================================================================
// Includes
// =====================================================================================

#include "global.h"

#include "LED_display.h"
#include "Key_Panel.h"
#include "LED_row.h"
#include "ISR.h"

// =====================================================================================
// Unterprogramme
// =====================================================================================

void LED_display_init(void)
{
	// Ports initialisieren
	DDRC |= DIG_1 | DIG_2 | DIG_3 | DIG_4;			// Ausgang Ziffern
	DDRD = 0xFF;									// Ausgang Segmente

	// Timer initialisieren -> LED-Anzeige: 8 MHz / 256 / 30 ~ 1040 Hz
	TCCR0 = (1<<WGM01);								// CTC
	TCCR0 |= (1<<CS00) | (1<<CS01);					// Vorteiler = 256
	OCR0 = 30;										// Compare-Wert = 30
	TCNT0 = 0;

	// Interrupts initialisieren
	TIMSK |= (1<<OCIE0);							// Interrupt zur Steuerung LED Mulitplexing
}

void LED_display_output(uint16_t number)
{
	// Zahl in Ziffern zerlegen
	
	// Einser
	digit[3] = number % 10;
	number = number / 10;
	
	// Zehner
	if (number > 0)
	{
		digit[2] = number % 10;
	}
	else
	{
		digit[2] = 10;
	}
	number = number / 10;
	
	// Hunderter
	if (number > 0)
	{
		digit[1] = number % 10;
	}
	else
	{
		digit[1] = 10;
	}
	number = number / 10;
	
	
	// Tausender
	if (number > 0)
	{
		digit[0] = number % 10;
	}
	else
	{
		digit[0] = 10;
	}

	display_on = 1;
}

void LED_display_off(void)
{
	// alle Ziffern und Segmente ausschalten
	PORTC &= ~(DIG_1 | DIG_2 | DIG_3 | DIG_4);
	PORTD = 0;
	display_on = 0;
}

// =====================================================================================
// Interrupt Service Routinen
// =====================================================================================

//ISR(TIMER0_COMP_vect)
//{
	//uint8_t segmente;
//
	//if (display_on==1)
	//{
		//// aktuelle Ziffer im Multiplexing
		//aktStelle++;
		//if (aktStelle==4)
		//{
			//aktStelle=0;
		//}
//
		//// alle Ziffern ausschalten
		//PORTC &= ~(DIG_1 | DIG_2 | DIG_3 | DIG_4);
//
		//// Segmente aktivieren
		//memcpy_P(&segmente, segmente_array + digit[aktStelle], sizeof(uint8_t));
		//PORTD = segmente;
//
		//// Ziffer aktivieren
		//PORTC |= (1<<(3-aktStelle));
	//}
//}
